#include <windows.h>
#include <tchar.h>
#include "regex.h"
#include "parse.h"

// ŏIG[擾
TCHAR gErrorMessage[1024] = _T("");

LPCTSTR GetLastParseErrorMessage(void) {
	return gErrorMessage;
}

void SetErrorMessage(LPCTSTR message) {
	_tcscpy_s(gErrorMessage, 1023, message);
}

bool IsLastError(void) {
	return (_tcslen(gErrorMessage) > 0);
}

// ݓt擾
#ifndef __DUMMY_GETNOW__ //_~[Ȃꍇɖ{
void GetNow(LPSYSTEMTIME lpTime) {
	GetLocalTime(lpTime);
}
#endif

// 2ɕĐlɕϊ
bool SplitNum(LPCTSTR str, WORD *lpValues, int *lpSize) {
	size_t slen = 0;
	int size = 0;
	TCHAR *halfstr = NULL;

	//
	ZeroMemory(lpValues, sizeof(WORD) * *lpSize);

	//Sp𔼊p
	slen = _tcslen(str) * 2 + 1;
	halfstr = new TCHAR[slen];
	ZeroMemory(halfstr, sizeof(TCHAR) * slen);
	LCMapString(LOCALE_USER_DEFAULT, LCMAP_HALFWIDTH,
		str, (int)_tcslen(str), halfstr, (int)slen);

	//߂B
	size = (int)_tcslen(halfstr);
	if (size % 2 != 0) {
		delete[] halfstr;
		return false;
	}
	size /= 2;
	if (size > *lpSize) {
		delete[] halfstr;
		return false;
	}
	*lpSize = size;
	
	//2ĂB
	TCHAR *p = halfstr;
	for (int i = 0; i < size; i++) {
		_stscanf(p, _T("%02d"), (lpValues + i));
		p += 2;
	}

	delete[] halfstr;
	return true;
}

// wN̍ŏI擾B
WORD GetLastDay(WORD year, WORD month) {
	switch (month) {
		case 1:
		case 3:
		case 5:
		case 7:
		case 8:
		case 10:
		case 12:
			return 31;
		case 2:
			return 28 + ((year % 4) == 0 && (year % 100) != 0 || (year % 400) == 0 ? 1 : 0);
		case 4:
		case 6:
		case 9:
		case 11:
			return 30;
		default:
			return 0;
	}
}

// m[}CY
void NormalizeDate(LPSYSTEMTIME lpTime) {
	//Jグ
	while (lpTime->wMinute > 59) {
		lpTime->wMinute -= 60;
		lpTime->wHour += 1;
	}

	//Jグ
	while (lpTime->wHour > 23) {
		lpTime->wHour -= 24;
		lpTime->wDay += 1;
	}

	//Jグ
	while (lpTime->wMonth > 12) {
		lpTime->wMonth -= 12;
		lpTime->wYear += 1;
	}

	//Jグ
	while (lpTime->wDay > GetLastDay(lpTime->wYear, lpTime->wMonth)) {
		lpTime->wDay -= GetLastDay(lpTime->wYear, lpTime->wMonth);
		lpTime->wMonth += 1;
		if (lpTime->wMonth > 12) {
			lpTime->wMonth -= 12;
			lpTime->wYear += 1;
		}
	}
}

// t̑召`FbN
int CompareSystemTime(LPSYSTEMTIME lpTime1, LPSYSTEMTIME lpTime2) {
	int ret = lpTime1->wYear - lpTime2->wYear;
	if (ret == 0) ret = lpTime1->wMonth - lpTime2->wMonth;
	if (ret == 0) ret = lpTime1->wDay - lpTime2->wDay;
	if (ret == 0) ret = lpTime1->wHour - lpTime2->wHour;
	if (ret == 0) ret = lpTime1->wMinute - lpTime2->wMinute;
	//b͎gȂ̂Ŗ`FbN
	return (ret > 0 ? 1 : (ret < 0 ? -1 : 0));
}

// ̑召`FbN
int CompareHM(LPSYSTEMTIME lpTime1, LPSYSTEMTIME lpTime2) {
	int ret = lpTime1->wHour - lpTime2->wHour;
	if (ret == 0) ret = lpTime1->wMinute - lpTime2->wMinute;
	return (ret > 0 ? 1 : (ret < 0 ? -1 : 0));
}

// ̑召`FbN
int CompareD(LPSYSTEMTIME lpTime1, LPSYSTEMTIME lpTime2) {
	int ret = lpTime1->wDay - lpTime2->wDay;
	return (ret > 0 ? 1 : (ret < 0 ? -1 : 0));
}

// ̑召`FbN
int CompareMD(LPSYSTEMTIME lpTime1, LPSYSTEMTIME lpTime2) {
	int ret = lpTime1->wMonth - lpTime2->wMonth;
	if (ret == 0) {
		return CompareD(lpTime1, lpTime2);
	} else {
		return (ret > 0 ? 1 : (ret < 0 ? -1 : 0));
	}
}

// N␳
void OffsetDay(LPSYSTEMTIME lpTime, LPSYSTEMTIME lpBaseTime) {
	lpTime->wYear = lpBaseTime->wYear;
	lpTime->wMonth = lpBaseTime->wMonth;
	lpTime->wDay = lpBaseTime->wDay;
	if (CompareHM(lpTime, lpBaseTime) < 0) {
		lpTime->wDay += 1;
	}
}

// N␳
void OffsetMonth(LPSYSTEMTIME lpTime, LPSYSTEMTIME lpBaseTime) {
	lpTime->wYear = lpBaseTime->wYear;
	lpTime->wMonth = lpBaseTime->wMonth;
	if (CompareD(lpTime, lpBaseTime) < 0) {
		lpTime->wMonth += 1;
	}
}

// N␳
void OffsetYear(LPSYSTEMTIME lpTime, LPSYSTEMTIME lpBaseTime) {
	lpTime->wYear = lpBaseTime->wYear;
	if (CompareMD(lpTime, lpBaseTime) < 0) {
		lpTime->wYear += 1;
	}
}

// ݒ肷
void SetBaseTime(LPSYSTEMTIME lpTime, bool IsAllDay, LPSYSTEMTIME lpBaseTime) {
	lpTime->wYear = lpBaseTime->wYear;
	lpTime->wMonth = lpBaseTime->wMonth;
	lpTime->wDay = lpBaseTime->wDay;
	//IłȂ΁A̈ꎞԌƂB
	if (!IsAllDay) {
		lpTime->wHour = lpBaseTime->wHour + 1;
		lpTime->wMinute = lpBaseTime->wMinute;
	}
}

// ̃p[X
bool ParseDate(LPCTSTR str, LPSYSTEMTIME lpTime, bool *lpIsAllDay, LPSYSTEMTIME lpBaseTime) {
	size_t len = 0;

	ZeroMemory(lpTime, sizeof(SYSTEMTIME));

	//󕶎ȂI
	if (str == NULL || *str == _T('\0')) {
		SetErrorMessage(_T(""));
		return false;
	}

	//2lɕϊ
	WORD values[7];
	int size = 6;
	if (!SplitNum(str, values, &size)) {
		SetErrorMessage(_T("ť`ԈĂ܂B"));
		return false;
	}

	switch (size) {
		case 1: //dd or hh
			if (*lpIsAllDay) { //dd
				lpTime->wDay = values[0];
				OffsetMonth(lpTime, lpBaseTime);
			} else { //hh
				lpTime->wHour = values[0];
				OffsetDay(lpTime, lpBaseTime);
			}
			break;
		case 2: //mmdd or hhmm
			if (*lpIsAllDay) { //mmdd
				lpTime->wMonth = values[0];
				lpTime->wDay = values[1];
				OffsetYear(lpTime, lpBaseTime);
			} else { //hhmm
				lpTime->wHour = values[0];
				lpTime->wMinute = values[1];
				OffsetDay(lpTime, lpBaseTime);
			}
			break;
		case 3: //mmddhh
			lpTime->wMonth = values[0];
			lpTime->wDay = values[1];
			lpTime->wHour = values[2];
			OffsetYear(lpTime, lpBaseTime);
			*lpIsAllDay = false;
			break;
		case 4: //yyyymmdd or mmddhhmm
			if (values[0] > 12) { //yyyymmdd
				lpTime->wYear = values[0] * 100 + values[1];
				lpTime->wMonth = values[2];
				lpTime->wDay = values[3];
				*lpIsAllDay = true;
			} else { //mmddhhmm
				lpTime->wMonth = values[0];
				lpTime->wDay = values[1];
				lpTime->wHour = values[2];
				lpTime->wMinute = values[3];
				OffsetYear(lpTime, lpBaseTime);
				*lpIsAllDay = false;
			}
			break;
		case 5: //yyyymmddhh
			lpTime->wYear = values[0] * 100 + values[1];
			lpTime->wMonth = values[2];
			lpTime->wDay = values[3];
			lpTime->wHour = values[4];
			*lpIsAllDay = false;
			break;
		case 6: //yyyymmddhhmm
			lpTime->wYear = values[0] * 100 + values[1];
			lpTime->wMonth = values[2];
			lpTime->wDay = values[3];
			lpTime->wHour = values[4];
			lpTime->wMinute = values[5];
			*lpIsAllDay = false;
			break;
		default:
			SetErrorMessage(_T("ť`ԈĂ܂B"));
			return false;
	}

	return true;
}

// ʂ̃p[X
bool ParseBase(LPCTSTR lpCmdLine, CRegex& re) {
	LPTSTR pattern = _T("^[\\s@]*([\\dO-X]+)?([-[|]([\\dO-X]+))?[\\s@]*(([^@]*)([@]([^\\s@]*))?)[\\s@]*$");
	re.SetPattern(pattern);
	if (re.Search(lpCmdLine) == 0) {
		SetErrorMessage(_T("͌`ԈĂ܂B"));
		return false;
	}
	return true;
}

// \Ƃăp[X
bool ParseAppointment(LPCTSTR lpCmdLine, ITEM* lpItem) {
	CRegex re;

	if (!ParseBase(lpCmdLine, re)) {
		return false;
	}

	//Eꏊ̐ݒ
	LPTSTR buff;
	buff = re.GetMatch(5);
	if (buff) lpItem->Subject = buff;
	buff = re.GetMatch(7);
	if (buff) lpItem->Location = buff;

	//ݎ00ƂB
	SYSTEMTIME now;
	GetNow(&now);
	now.wMinute = 0;

	//JňvZ
	lpItem->IsAllDayEvent = true; //ID
	bool existStartDate = ParseDate(re.GetMatch(1), &lpItem->StartTime, &lpItem->IsAllDayEvent, &now);
	if (!existStartDate) {
		if (IsLastError()) {
			return false;
		}
		//󕶎ȂAݒ
		SetBaseTime(&lpItem->StartTime, lpItem->IsAllDayEvent, &now);
	}
	NormalizeDate(&lpItem->StartTime);

	//ǏvZ
	bool prevAllDayEvent = lpItem->IsAllDayEvent;
	if (!ParseDate(re.GetMatch(3), &lpItem->EndTime, &lpItem->IsAllDayEvent, &lpItem->StartTime)) {
		if (IsLastError()) {
			return false;
		}
		//󕶎ȂAݒ
		SetBaseTime(&lpItem->EndTime, lpItem->IsAllDayEvent, &lpItem->StartTime);
	} else if (!existStartDate) {
		SetErrorMessage(_T("Î݂̓͂͂ł܂B"));
		return false;
	}
	//Iǂ؂ւĂNG
	if (!prevAllDayEvent && lpItem->IsAllDayEvent) {
		//JnFIłȂAIFȈꍇ
		SetErrorMessage(_T("I\ł͂Ȃ߁AIɎ͂ĂB"));
		return false;
	} else if (prevAllDayEvent && !lpItem->IsAllDayEvent) {
		//JnFIAIFIłȂꍇ
		SetErrorMessage(_T("I\̂߁AIɎ͓͂ł܂B"));
		return false;
	}

	NormalizeDate(&lpItem->EndTime);

	//t̑召r
	if (CompareSystemTime(&lpItem->StartTime, &lpItem->EndTime) > 0) {
		SetErrorMessage(_T("JnIłB"));
		return false;
	}

	return true;
}

// dƂăp[X
bool ParseTask(LPCTSTR lpCmdLine, ITEM* lpItem) {
	CRegex re;

	if (!ParseBase(lpCmdLine, re)) {
		return false;
	}

	//̓o^
	LPTSTR buff;
	buff = re.GetMatch(4);
	if (buff) lpItem->Subject = buff;

	//ݎ0000ƂB
	SYSTEMTIME now;
	GetNow(&now);
	now.wHour = 0;
	now.wMinute = 0;

	//JňvZ
	lpItem->IsAllDayEvent = true; //ID
	bool existStartDate = ParseDate(re.GetMatch(1), &lpItem->StartTime, &lpItem->IsAllDayEvent, &now);
	if (!existStartDate &&IsLastError()) {
		return false;
	}
	if (!lpItem->IsAllDayEvent) {
		SetErrorMessage(_T("dł͎̓͂͂ł܂B"));
		return false;
	}
	NormalizeDate(&lpItem->StartTime);

	//̌vZ
	if (existStartDate) {
		//Jn͂ĂȂA̓ƂB
		CopyMemory(&now, &lpItem->StartTime, sizeof(SYSTEMTIME));
	}
	bool existEndDate = ParseDate(re.GetMatch(3), &lpItem->EndTime, &lpItem->IsAllDayEvent, &now);
	if (!existEndDate) {
		if (IsLastError()) {
			return false;
		} else if (existStartDate) {
			//̓͂āAJn͂ĂȂA
			//JnɒuB
			CopyMemory(&lpItem->EndTime, &lpItem->StartTime, sizeof(SYSTEMTIME));
			ZeroMemory(&lpItem->StartTime, sizeof(SYSTEMTIME));
		}
	}
	if (!lpItem->IsAllDayEvent) {
		SetErrorMessage(_T("dł͎̓͂͂ł܂B"));
		return false;
	}
	NormalizeDate(&lpItem->EndTime);

	//t̑召r
	if (existStartDate && existEndDate &&
		CompareSystemTime(&lpItem->StartTime, &lpItem->EndTime) > 0) {
		SetErrorMessage(_T("JnłB"));
		return false;
	}

	return true;
}
