// pimreg.cpp : AvP[ṼGg |Cg`܂B
//

#include <windows.h>
#include <tchar.h>
#include "pimreg.h"
#include "regex.h"
#include "poom.h"

typedef enum {
	MODE_APPOINTMENT = 1,
	MODE_TASK = 2,
} E_MODE;

struct {
	bool IsDirectRegist;
	bool IsConfirmDialog;
	bool IsReminderSet;
	E_MODE Mode;
} gOptions;

bool mIsComfirm = false;

// IvVp[XB
void ParseOption(LPTSTR &lpCmdLine) {
	gOptions.IsDirectRegist = false;
	gOptions.IsConfirmDialog = false;
	gOptions.IsReminderSet = false;
	gOptions.Mode = MODE_APPOINTMENT;

	CRegex re;
	re.SetIgnoreCase(TRUE);
	re.SetPattern(_T("^\\s*(/(\\w)(:(\\S+))?)"));
	while (re.Search(lpCmdLine) > 0) {
		LPTSTR opt = re.GetMatch(2);
		if (_tcsicmp(opt, _T("d")) == 0) {
			//ړo^
			gOptions.IsDirectRegist = true;
		} else if (_tcsicmp(opt, _T("c")) == 0) {
			//mF_CAO\
			gOptions.IsConfirmDialog = true;
		} else if (_tcsicmp(opt, _T("t")) == 0) {
			//^XNo^[h
			gOptions.Mode = MODE_TASK;
		} else if (_tcsicmp(opt, _T("a")) == 0) {
			LPTSTR param = re.GetMatch(4);
			if (_tcsicmp(param, _T("off")) == 0) {
				//A[gȂ
				gOptions.IsReminderSet = false;
			} else if (_tcsicmp(param, _T("on")) == 0) {
				//A[g
				gOptions.IsReminderSet = true;
			}
		}

		lpCmdLine = re.GetNext();
	}
}

// bZ[W\
void DisplayMessage(LPCTSTR message) {
	MessageBox(NULL, message, _T("PIM Register"), MB_OK);
}

// t𕶎ɕϊ
void FormatDate(LPTSTR str, const SYSTEMTIME *lpTime) {
	SYSTEMTIME empty;
	ZeroMemory(&empty, sizeof(SYSTEMTIME));
	if (memcmp(lpTime, &empty, sizeof(SYSTEMTIME)) == 0) {
		str[0] = _T('\0');
	} else if (lpTime->wHour == 0) {
		wsprintf(str, _T("%04d/%02d/%02d"), lpTime->wYear, lpTime->wMonth, lpTime->wDay);
	} else {
		wsprintf(str, _T("%04d/%02d/%02d %02d:%02d"),
			lpTime->wYear, lpTime->wMonth, lpTime->wDay, lpTime->wHour, lpTime->wMinute);
	}
}

// mF_CAO\
bool Confirm(const ITEM& item) {
	TCHAR start[20], end[20];
	TCHAR message[1024], buff[1024];
	ZeroMemory(message, sizeof(TCHAR) * 1024);
	ZeroMemory(buff, sizeof(TCHAR) * 1024);
	FormatDate(start, &item.StartTime);
	FormatDate(end, &item.EndTime);

	_sntprintf(message, 1024, _T("ȉ%so^܂B낵łH\n")
		, ((gOptions.Mode == MODE_APPOINTMENT) ? _T("\") : _T("d")));
	switch (gOptions.Mode) {
		case MODE_APPOINTMENT:
			_sntprintf(buff, 1024, _T(":%s\n"), item.Subject.c_str());
			_tcscat_s(message, 1024, buff);
			if (!item.Location.empty()) {
				_sntprintf(buff, 1024, _T("ꏊ:%s\n"), item.Location.c_str());
				_tcscat_s(message, 1024, buff);
			}
			_sntprintf(buff, 1024, _T("Jn:%s\n"), start);
			_tcscat_s(message, 1024, buff);
			_sntprintf(buff, 1024, _T("I:%s\n"), end);
			_tcscat_s(message, 1024, buff);
			if (item.IsAllDayEvent) {
				_tcscat_s(message, 1024, _T("IF͂\n"));
			} else {
				_tcscat_s(message, 1024, _T("IF\n"));
			}
			break;
		case MODE_TASK:
			_sntprintf(buff, 1024, _T(":%s\n"), item.Subject.c_str());
			_tcscat_s(message, 1024, buff);
			if (_tcslen(start) > 0) {
				_sntprintf(buff, 1024, _T("Jn:%s\n"), start);
				_tcscat_s(message, 1024, buff);
			}
			if (_tcslen(end) > 0) {
				_sntprintf(buff, 1024, _T(":%s\n"), end);
				_tcscat_s(message, 1024, buff);
			}
			break;
		default:
			return false;
	}

	return (MessageBox(NULL, message, _T("PIM Register"), MB_YESNO) == IDYES);
}

// C
int WINAPI WinMain(HINSTANCE hInstance,
                   HINSTANCE hPrevInstance,
                   LPTSTR    lpCmdLine,
                   int       nCmdShow)
{
	bool ret = false;

	//IvṼp[X
	ParseOption(lpCmdLine);

	//o^p[X
	ITEM item;
	ZeroMemory(&item, sizeof(ITEM));
	switch (gOptions.Mode) {
		case MODE_APPOINTMENT:
			ret = ParseAppointment(lpCmdLine, &item);
			break;
		case MODE_TASK:
			ret = ParseTask(lpCmdLine, &item);
			break;
		default:
			return 1;
	}
	if (!ret) {
		DisplayMessage(GetLastParseErrorMessage());
		return 1;
	}
	
	//mF_CAOo
	if (gOptions.IsConfirmDialog && !Confirm(item)) {
		return 0;
	}

	//o^
	POOM::CApp app;
	switch (gOptions.Mode) {
		case MODE_APPOINTMENT:
			ret = app.CreateAppointment(item, gOptions.IsReminderSet);
			break;
		case MODE_TASK:
			ret = app.CreateTask(item, gOptions.IsReminderSet);
			break;
		default:
			return 1;
	}
	if (!ret) {
		DisplayMessage(_T("o^Ɏs܂B"));
		return 1;
	}

	return 0;
}
