// pimreg_test.cpp : R\[ AvP[ṼGg |Cg`܂B
//

#include <windows.h>
#include <tchar.h>
#include "..\pimreg\parse.h"

// fobOo
void OutputDebug(LPCTSTR lpFormat, ...) {
	va_list args;
	va_start(args, lpFormat);
	TCHAR message[2048];
	_vstprintf_s(message, 2048, lpFormat, args);
	OutputDebugString(message);
}

// t𕶎ɕϊ
void FormatDate(LPTSTR str, const SYSTEMTIME& dt) {
	wsprintf(str, _T("%04d/%02d/%02d %02d:%02d"),
		dt.wYear, dt.wMonth, dt.wDay, dt.wHour, dt.wMinute);
}

tstring ConvertToExpectedValue(ITEM& item) {
	TCHAR st[20], ed[20];
	FormatDate(st, item.StartTime);
	FormatDate(ed, item.EndTime);
	tstring result;
	result = tstring(st) + _T(",")
		   + tstring(ed) + _T(",")
		   + item.Subject + _T(",")
		   + item.Location + _T(",")
		   + (item.IsAllDayEvent ? _T("true") : _T("false"));
	return result;
}

void Assert(bool (*lpFunc)(LPCTSTR, ITEM*), LPCTSTR lpExpected, LPCTSTR lpActual) {
	//p[Xĕϊ
	ITEM item;
	ZeroMemory(&item, sizeof(item));

	if (lpFunc(lpActual, &item)) {
		//ꍇAʂƔr
		tstring actual = ConvertToExpectedValue(item);
		if (_tcscmp(lpExpected, actual.c_str()) != 0) {
			OutputDebug(_T("%ss: [%s] expected [%s]. but was [%s]\n"), 
				(lpFunc == ParseAppointment ? _T("\") : _T("d")),
				lpActual, lpExpected, actual.c_str());
		}
	} else {
		//sꍇAG[bZ[WƔr
		LPCTSTR message = GetLastParseErrorMessage();
		if (_tcscmp(lpExpected, message) != 0) {
			OutputDebug(_T("%ss: [%s] expected [%s]. but was [%s]\n"),
				(lpFunc == ParseAppointment ? _T("\") : _T("d")),
				lpActual, lpExpected, message);
		}
	}

}

//2009/12/15 21:15ƂB
void GetNow(LPSYSTEMTIME lpTime) {
	lpTime->wYear = 2009;
	lpTime->wMonth = 12;
	lpTime->wDay = 15;
	lpTime->wHour = 21;
	lpTime->wMinute = 15;
	lpTime->wSecond = 0;
	lpTime->wMilliseconds = 0;
	lpTime->wDayOfWeek = 3;
}

//\̃eXg
void AssertAppointments(void) {
	//Sp
	Assert(ParseAppointment, _T("2009/12/20 00:00,2009/12/20 00:00,,,true"), _T("PQQO"));
	Assert(ParseAppointment, _T("2009/12/18 00:00,2009/12/18 00:00,,,true"), _T("P2P8"));

	//ꏊ
	Assert(ParseAppointment, _T("2009/12/20 00:00,2009/12/20 00:00,,ꏊ,true"), _T("PQQO@ꏊ"));
	Assert(ParseAppointment, _T("2009/12/20 00:00,2009/12/20 00:00,,΂,true"), _T("PQQO΂"));

	//OɃXy[X
	Assert(ParseAppointment, _T("2009/12/20 00:00,2009/12/20 00:00,,ꏊ,true"), _T("PQQO    @ꏊ@"));

	//JnIȂ
	Assert(ParseAppointment, _T("2009/12/15 00:00,2009/12/15 00:00,,,true"), _T(""));

	//Jn̓̓G[
	Assert(ParseAppointment, _T("ť`ԈĂ܂B"), _T("1"));
	Assert(ParseAppointment, _T("ť`ԈĂ܂B"), _T("123"));
	Assert(ParseAppointment, _T("ť`ԈĂ܂B"), _T("12345"));
	Assert(ParseAppointment, _T("ť`ԈĂ܂B"), _T("1234567"));
	Assert(ParseAppointment, _T("ť`ԈĂ܂B"), _T("123456789"));
	Assert(ParseAppointment, _T("ť`ԈĂ܂B"), _T("12345678901"));
	Assert(ParseAppointment, _T("ť`ԈĂ܂B"), _T("1234567890123"));
	Assert(ParseAppointment, _T("ť`ԈĂ܂B"), _T("12345678901234"));

	//Jn̂()
	Assert(ParseAppointment, _T("2010/01/05 00:00,2010/01/05 00:00,,,true"), _T("05"));
	Assert(ParseAppointment, _T("2010/01/14 00:00,2010/01/14 00:00,,,true"), _T("14"));
	Assert(ParseAppointment, _T("2009/12/15 00:00,2009/12/15 00:00,,,true"), _T("15"));
	Assert(ParseAppointment, _T("2009/12/16 00:00,2009/12/16 00:00,,,true"), _T("16"));

	//Jn̂()
	Assert(ParseAppointment, _T("2010/02/05 00:00,2010/02/05 00:00,,,true"), _T("0205"));
	Assert(ParseAppointment, _T("2010/12/14 00:00,2010/12/14 00:00,,,true"), _T("1214"));
	Assert(ParseAppointment, _T("2009/12/15 00:00,2009/12/15 00:00,,,true"), _T("1215"));
	Assert(ParseAppointment, _T("2009/12/16 00:00,2009/12/16 00:00,,,true"), _T("1216"));

	//Jn̂(N)
	Assert(ParseAppointment, _T("2008/01/05 00:00,2008/01/05 00:00,,,true"), _T("20080105"));
	Assert(ParseAppointment, _T("2008/12/14 00:00,2008/12/14 00:00,,,true"), _T("20081214"));
	Assert(ParseAppointment, _T("2008/12/15 00:00,2008/12/15 00:00,,,true"), _T("20081215"));
	Assert(ParseAppointment, _T("2008/12/16 00:00,2008/12/16 00:00,,,true"), _T("20081216"));

	//Jn̂()
	Assert(ParseAppointment, _T("2010/12/14 13:00,2010/12/14 14:00,,,false"), _T("121413"));
	Assert(ParseAppointment, _T("2009/12/15 13:00,2009/12/15 14:00,,,false"), _T("121513"));
	Assert(ParseAppointment, _T("2009/12/16 23:00,2009/12/17 00:00,,,false"), _T("121623"));

	//Jn̂()
	Assert(ParseAppointment, _T("2010/12/14 13:30,2010/12/14 14:30,,,false"), _T("12141330"));
	Assert(ParseAppointment, _T("2009/12/15 13:30,2009/12/15 14:30,,,false"), _T("12151330"));
	Assert(ParseAppointment, _T("2009/12/16 23:30,2009/12/17 00:30,,,false"), _T("12162330"));

	//Jn̂(N)
	Assert(ParseAppointment, _T("2008/01/05 13:00,2008/01/05 14:00,,,false"), _T("2008010513"));
	Assert(ParseAppointment, _T("2008/12/14 13:00,2008/12/14 14:00,,,false"), _T("2008121413"));
	Assert(ParseAppointment, _T("2008/12/15 13:00,2008/12/15 14:00,,,false"), _T("2008121513"));
	Assert(ParseAppointment, _T("2008/12/16 23:00,2008/12/17 00:00,,,false"), _T("2008121623"));

	//Jn̂(N)
	Assert(ParseAppointment, _T("2008/01/05 13:30,2008/01/05 14:30,,,false"), _T("200801051330"));
	Assert(ParseAppointment, _T("2008/12/14 13:30,2008/12/14 14:30,,,false"), _T("200812141330"));
	Assert(ParseAppointment, _T("2008/12/15 13:30,2008/12/15 14:30,,,false"), _T("200812151330"));
	Assert(ParseAppointment, _T("2008/12/16 23:30,2008/12/17 00:30,,,false"), _T("200812162330"));

	//I̓̓G[
	Assert(ParseAppointment, _T("ť`ԈĂ܂B"), _T("1002-1"));
	Assert(ParseAppointment, _T("ť`ԈĂ܂B"), _T("1002-123"));
	Assert(ParseAppointment, _T("ť`ԈĂ܂B"), _T("1002-12345"));
	Assert(ParseAppointment, _T("ť`ԈĂ܂B"), _T("1002-1234567"));
	Assert(ParseAppointment, _T("ť`ԈĂ܂B"), _T("1002-123456789"));
	Assert(ParseAppointment, _T("ť`ԈĂ܂B"), _T("1002-12345678901"));
	Assert(ParseAppointment, _T("ť`ԈĂ܂B"), _T("1002-1234567890123"));
	Assert(ParseAppointment, _T("ť`ԈĂ܂B"), _T("1002-12345678901234"));

	//JnI(-)
	Assert(ParseAppointment, _T("2010/01/05 00:00,2010/02/03 00:00,,,true"), _T("05-03"));
	Assert(ParseAppointment, _T("2009/12/20 00:00,2010/01/19 00:00,,,true"), _T("20-19"));
	Assert(ParseAppointment, _T("2009/12/20 00:00,2009/12/20 00:00,,,true"), _T("20-20"));
	Assert(ParseAppointment, _T("2009/12/20 00:00,2009/12/21 00:00,,,true"), _T("20-21"));

	//JnI(-)
	Assert(ParseAppointment, _T("2010/01/05 00:00,2010/12/08 00:00,,,true"), _T("05-1208"));
	Assert(ParseAppointment, _T("2010/01/05 00:00,2011/01/04 00:00,,,true"), _T("05-0104"));
	Assert(ParseAppointment, _T("2009/12/20 00:00,2010/01/04 00:00,,,true"), _T("20-0104"));

	//JnI(-N)
	Assert(ParseAppointment, _T("2009/12/16 00:00,2010/12/20 00:00,,,true"), _T("16-20101220"));
	Assert(ParseAppointment, _T("JnIłB"), _T("16-20090801"));

	//JnI(-)
	Assert(ParseAppointment, _T("I\̂߁AIɎ͓͂ł܂B"), _T("15-121610"));

	//JnI(-)
	Assert(ParseAppointment, _T("I\̂߁AIɎ͓͂ł܂B"), _T("15-12161015"));

	//JnI(-N)
	Assert(ParseAppointment, _T("I\̂߁AIɎ͓͂ł܂B"), _T("15-2009121610"));

	//JnI(-N)
	Assert(ParseAppointment, _T("I\̂߁AIɎ͓͂ł܂B"), _T("15-200912161015"));

	//JnI(-)
	Assert(ParseAppointment, _T("2010/01/05 00:00,2010/01/08 00:00,,,true"), _T("0105-08"));
	Assert(ParseAppointment, _T("2010/01/20 00:00,2010/02/19 00:00,,,true"), _T("0120-19"));
	Assert(ParseAppointment, _T("2010/01/20 00:00,2010/01/20 00:00,,,true"), _T("0120-20"));
	Assert(ParseAppointment, _T("2010/01/20 00:00,2010/01/21 00:00,,,true"), _T("0120-21"));

	//JnI(-)
	Assert(ParseAppointment, _T("2010/01/05 00:00,2010/12/08 00:00,,,true"), _T("0105-1208"));
	Assert(ParseAppointment, _T("2010/01/05 00:00,2011/01/04 00:00,,,true"), _T("0105-0104"));

	//JnI(-N)
	Assert(ParseAppointment, _T("2009/12/15 00:00,2010/12/20 00:00,,,true"), _T("1215-20101220"));
	Assert(ParseAppointment, _T("JnIłB"), _T("1216-20090801"));

	//JnI(-)
	Assert(ParseAppointment, _T("I\̂߁AIɎ͓͂ł܂B"), _T("1215-121610"));

	//JnI(-)
	Assert(ParseAppointment, _T("I\̂߁AIɎ͓͂ł܂B"), _T("1215-12161015"));

	//JnI(-N)
	Assert(ParseAppointment, _T("I\̂߁AIɎ͓͂ł܂B"), _T("1215-2009121610"));

	//JnI(-N)
	Assert(ParseAppointment, _T("I\̂߁AIɎ͓͂ł܂B"), _T("1215-200912161015"));

	//JnI(N-)
	Assert(ParseAppointment, _T("2009/01/05 00:00,2009/01/08 00:00,,,true"), _T("20090105-08"));
	Assert(ParseAppointment, _T("2009/01/20 00:00,2009/02/19 00:00,,,true"), _T("20090120-19"));
	Assert(ParseAppointment, _T("2009/01/20 00:00,2009/01/20 00:00,,,true"), _T("20090120-20"));
	Assert(ParseAppointment, _T("2009/01/20 00:00,2009/01/21 00:00,,,true"), _T("20090120-21"));

	//JnI(N-)
	Assert(ParseAppointment, _T("2009/01/05 00:00,2009/12/08 00:00,,,true"), _T("20090105-1208"));
	Assert(ParseAppointment, _T("2009/01/05 00:00,2010/01/04 00:00,,,true"), _T("20090105-0104"));

	//JnI(N-N)
	Assert(ParseAppointment, _T("2008/12/15 00:00,2010/12/20 00:00,,,true"), _T("20081215-20101220"));
	Assert(ParseAppointment, _T("JnIłB"), _T("20091216-20090801"));

	//JnI(N-)
	Assert(ParseAppointment, _T("I\̂߁AIɎ͓͂ł܂B"), _T("20091215-121610"));

	//JnI(N-)
	Assert(ParseAppointment, _T("I\̂߁AIɎ͓͂ł܂B"), _T("20091215-12161015"));

	//JnI(N-N)
	Assert(ParseAppointment, _T("I\̂߁AIɎ͓͂ł܂B"), _T("20091215-2009121610"));

	//JnI(N-N)
	Assert(ParseAppointment, _T("I\̂߁AIɎ͓͂ł܂B"), _T("20091215-200912161015"));

	//JnI(-)
	Assert(ParseAppointment, _T("2010/01/05 20:00,2010/01/06 08:00,,,false"), _T("010520-08"));
	Assert(ParseAppointment, _T("2010/01/20 10:00,2010/01/20 19:00,,,false"), _T("012010-19"));

	//JnI(-)
	Assert(ParseAppointment, _T("2010/01/05 20:00,2010/01/06 08:30,,,false"), _T("010520-0830"));
	Assert(ParseAppointment, _T("2010/01/20 10:00,2010/01/20 19:30,,,false"), _T("012010-1930"));

	//JnI(-)
	Assert(ParseAppointment, _T("2010/01/05 20:00,2010/01/06 02:00,,,false"), _T("010520-010602"));
	Assert(ParseAppointment, _T("2010/01/20 10:00,2010/01/20 15:00,,,false"), _T("012010-012015"));

	//JnI(-)
	Assert(ParseAppointment, _T("2010/01/05 20:00,2010/01/06 02:30,,,false"), _T("010520-01060230"));
	Assert(ParseAppointment, _T("2010/01/20 10:00,2010/01/20 15:30,,,false"), _T("012010-01201530"));

	//JnI(-N)
	Assert(ParseAppointment, _T("2010/01/05 20:00,2010/01/06 02:00,,,false"), _T("010520-2010010602"));
	Assert(ParseAppointment, _T("2010/01/20 10:00,2010/01/20 15:00,,,false"), _T("012010-2010012015"));
	Assert(ParseAppointment, _T("JnIłB"), _T("012010-2009012015"));

	//JnI(-N)
	Assert(ParseAppointment, _T("2010/01/05 20:00,2010/01/06 02:30,,,false"), _T("010520-201001060230"));
	Assert(ParseAppointment, _T("2010/01/20 10:00,2010/01/20 15:30,,,false"), _T("012010-201001201530"));
	Assert(ParseAppointment, _T("JnIłB"), _T("012010-200901201530"));

	//JnI(-)
	Assert(ParseAppointment, _T("2010/01/05 20:30,2010/01/06 08:00,,,false"), _T("01052030-08"));
	Assert(ParseAppointment, _T("2010/01/20 10:30,2010/01/20 19:00,,,false"), _T("01201030-19"));

	//JnI(-)
	Assert(ParseAppointment, _T("2010/01/05 20:30,2010/01/06 08:30,,,false"), _T("01052030-0830"));
	Assert(ParseAppointment, _T("2010/01/20 10:30,2010/01/20 19:30,,,false"), _T("01201030-1930"));

	//JnI(-)
	Assert(ParseAppointment, _T("2010/01/05 20:30,2010/01/06 02:00,,,false"), _T("01052030-010602"));
	Assert(ParseAppointment, _T("2010/01/20 10:30,2010/01/20 15:00,,,false"), _T("01201030-012015"));

	//JnI(-)
	Assert(ParseAppointment, _T("2010/01/05 20:30,2010/01/06 02:30,,,false"), _T("01052030-01060230"));
	Assert(ParseAppointment, _T("2010/01/20 10:30,2010/01/20 15:30,,,false"), _T("01201030-01201530"));

	//JnI(-N)
	Assert(ParseAppointment, _T("2010/01/05 20:30,2010/01/06 02:00,,,false"), _T("01052030-2010010602"));
	Assert(ParseAppointment, _T("2010/01/20 10:30,2010/01/20 15:00,,,false"), _T("01201030-2010012015"));
	Assert(ParseAppointment, _T("JnIłB"), _T("01201030-2009012015"));

	//JnI(-N)
	Assert(ParseAppointment, _T("2010/01/05 20:30,2010/01/06 02:30,,,false"), _T("01052030-201001060230"));
	Assert(ParseAppointment, _T("2010/01/20 10:30,2010/01/20 15:30,,,false"), _T("01201030-201001201530"));
	Assert(ParseAppointment, _T("JnIłB"), _T("01201030-200901201530"));

	//JnI(N-)
	Assert(ParseAppointment, _T("2009/01/05 20:00,2009/01/06 08:00,,,false"), _T("2009010520-08"));
	Assert(ParseAppointment, _T("2009/01/20 10:00,2009/01/20 19:00,,,false"), _T("2009012010-19"));

	//JnI(N-)
	Assert(ParseAppointment, _T("2009/01/05 20:00,2009/01/06 08:30,,,false"), _T("2009010520-0830"));
	Assert(ParseAppointment, _T("2009/01/20 10:00,2009/01/20 19:30,,,false"), _T("2009012010-1930"));

	//JnI(N-)
	Assert(ParseAppointment, _T("2009/01/05 20:00,2009/01/06 02:00,,,false"), _T("2009010520-010602"));
	Assert(ParseAppointment, _T("2009/01/20 10:00,2009/01/20 15:00,,,false"), _T("2009012010-012015"));

	//JnI(N-)
	Assert(ParseAppointment, _T("2009/01/05 20:00,2009/01/06 02:30,,,false"), _T("2009010520-01060230"));
	Assert(ParseAppointment, _T("2009/01/20 10:00,2009/01/20 15:30,,,false"), _T("2009012010-01201530"));

	//JnI(N-N)
	Assert(ParseAppointment, _T("2009/01/05 20:00,2009/01/06 02:00,,,false"), _T("2009010520-2009010602"));
	Assert(ParseAppointment, _T("2009/01/20 10:00,2009/01/20 15:00,,,false"), _T("2009012010-2009012015"));
	Assert(ParseAppointment, _T("JnIłB"), _T("2009012010-2009012009"));

	//JnI(N-N)
	Assert(ParseAppointment, _T("2009/01/05 20:00,2009/01/06 02:30,,,false"), _T("2009010520-200901060230"));
	Assert(ParseAppointment, _T("2009/01/20 10:00,2009/01/20 15:30,,,false"), _T("2009012010-200901201530"));
	Assert(ParseAppointment, _T("JnIłB"), _T("2009012010-200901200959"));

	//JnI(N-)
	Assert(ParseAppointment, _T("2009/01/05 20:30,2009/01/06 08:00,,,false"), _T("200901052030-08"));
	Assert(ParseAppointment, _T("2009/01/20 10:30,2009/01/20 19:00,,,false"), _T("200901201030-19"));

	//JnI(N-)
	Assert(ParseAppointment, _T("2009/01/05 20:30,2009/01/06 08:30,,,false"), _T("200901052030-0830"));
	Assert(ParseAppointment, _T("2009/01/20 10:30,2009/01/20 19:30,,,false"), _T("200901201030-1930"));

	//JnI(N-)
	Assert(ParseAppointment, _T("2009/01/05 20:30,2009/01/06 02:00,,,false"), _T("200901052030-010602"));
	Assert(ParseAppointment, _T("2009/01/20 10:30,2009/01/20 15:00,,,false"), _T("200901201030-012015"));

	//JnI(N-)
	Assert(ParseAppointment, _T("2009/01/05 20:30,2009/01/06 02:30,,,false"), _T("200901052030-01060230"));
	Assert(ParseAppointment, _T("2009/01/20 10:30,2009/01/20 15:30,,,false"), _T("200901201030-01201530"));

	//JnI(N-N)
	Assert(ParseAppointment, _T("2009/01/05 20:30,2009/01/06 02:00,,,false"), _T("200901052030-2009010602"));
	Assert(ParseAppointment, _T("2009/01/20 10:30,2009/01/20 15:00,,,false"), _T("200901201030-2009012015"));
	Assert(ParseAppointment, _T("JnIłB"), _T("200901201030-2009012009"));

	//JnI(N-N)
	Assert(ParseAppointment, _T("2009/01/05 20:30,2009/01/06 02:30,,,false"), _T("200901052030-200901060230"));
	Assert(ParseAppointment, _T("2009/01/20 10:30,2009/01/20 15:30,,,false"), _T("200901201030-200901201530"));
	Assert(ParseAppointment, _T("JnIłB"), _T("200901201001-200901200959"));

	//I̓̓G[
	Assert(ParseAppointment, _T("ť`ԈĂ܂B"), _T("-1"));
	Assert(ParseAppointment, _T("ť`ԈĂ܂B"), _T("-123"));
	Assert(ParseAppointment, _T("ť`ԈĂ܂B"), _T("-12345"));
	Assert(ParseAppointment, _T("ť`ԈĂ܂B"), _T("-1234567"));
	Assert(ParseAppointment, _T("ť`ԈĂ܂B"), _T("-123456789"));
	Assert(ParseAppointment, _T("ť`ԈĂ܂B"), _T("-12345678901"));
	Assert(ParseAppointment, _T("ť`ԈĂ܂B"), _T("-1234567890123"));
	Assert(ParseAppointment, _T("ť`ԈĂ܂B"), _T("-12345678901234"));
	Assert(ParseAppointment, _T("Î݂̓͂͂ł܂B"), _T("-05"));
	Assert(ParseAppointment, _T("Î݂̓͂͂ł܂B"), _T("-0501"));
	Assert(ParseAppointment, _T("Î݂̓͂͂ł܂B"), _T("-050110"));
	Assert(ParseAppointment, _T("Î݂̓͂͂ł܂B"), _T("-05011030"));
	Assert(ParseAppointment, _T("Î݂̓͂͂ł܂B"), _T("-20090501"));
	Assert(ParseAppointment, _T("Î݂̓͂͂ł܂B"), _T("-2009050110"));
	Assert(ParseAppointment, _T("Î݂̓͂͂ł܂B"), _T("-200905011030"));
}

void AssertTasks(void) {
	//Sp
	Assert(ParseTask, _T("0000/00/00 00:00,2009/12/20 00:00,,,true"), _T("PQQO"));
	Assert(ParseTask, _T("0000/00/00 00:00,2009/12/18 00:00,,,true"), _T("P2P8"));

	//ꏊ()
	Assert(ParseTask, _T("0000/00/00 00:00,2009/12/20 00:00,@ꏊ,,true"), _T("PQQO@ꏊ"));
	Assert(ParseTask, _T("0000/00/00 00:00,2009/12/20 00:00,΂,,true"), _T("PQQO΂"));

	//OɃXy[X
	Assert(ParseTask, _T("0000/00/00 00:00,2009/12/20 00:00,@ꏊ,,true"), _T("PQQO    @ꏊ@"));

	//t͂Ȃ
	Assert(ParseTask, _T("0000/00/00 00:00,0000/00/00 00:00,,,true"), _T(""));

	Assert(ParseTask, _T("2009/12/20 00:00,2009/12/23 00:00,,,true"), _T("1220-1223"));

	//t1̓̓G[
	Assert(ParseTask, _T("ť`ԈĂ܂B"), _T("1"));
	Assert(ParseTask, _T("ť`ԈĂ܂B"), _T("123"));
	Assert(ParseTask, _T("ť`ԈĂ܂B"), _T("12345"));
	Assert(ParseTask, _T("ť`ԈĂ܂B"), _T("1234567"));
	Assert(ParseTask, _T("ť`ԈĂ܂B"), _T("123456789"));
	Assert(ParseTask, _T("ť`ԈĂ܂B"), _T("12345678901"));
	Assert(ParseTask, _T("ť`ԈĂ܂B"), _T("1234567890123"));
	Assert(ParseTask, _T("ť`ԈĂ܂B"), _T("12345678901234"));
	Assert(ParseTask, _T("dł͎̓͂͂ł܂B"), _T("020510"));
	Assert(ParseTask, _T("dł͎̓͂͂ł܂B"), _T("02051030"));
	Assert(ParseTask, _T("dł͎̓͂͂ł܂B"), _T("2008020510"));
	Assert(ParseTask, _T("dł͎̓͂͂ł܂B"), _T("200802051030"));

	//t1̊̂()
	Assert(ParseTask, _T("0000/00/00 00:00,2010/01/14 00:00,,,true"), _T("14"));
	Assert(ParseTask, _T("0000/00/00 00:00,2009/12/15 00:00,,,true"), _T("15"));
	Assert(ParseTask, _T("0000/00/00 00:00,2009/12/16 00:00,,,true"), _T("16"));

	//t1̊̂()
	Assert(ParseTask, _T("0000/00/00 00:00,2010/02/05 00:00,,,true"), _T("0205"));
	Assert(ParseTask, _T("0000/00/00 00:00,2010/12/14 00:00,,,true"), _T("1214"));
	Assert(ParseTask, _T("0000/00/00 00:00,2009/12/15 00:00,,,true"), _T("1215"));
	Assert(ParseTask, _T("0000/00/00 00:00,2009/12/16 00:00,,,true"), _T("1216"));

	//t1̊̂(N)
	Assert(ParseTask, _T("0000/00/00 00:00,2008/01/05 00:00,,,true"), _T("20080105"));
	Assert(ParseTask, _T("0000/00/00 00:00,2008/12/14 00:00,,,true"), _T("20081214"));
	Assert(ParseTask, _T("0000/00/00 00:00,2008/12/15 00:00,,,true"), _T("20081215"));
	Assert(ParseTask, _T("0000/00/00 00:00,2008/12/16 00:00,,,true"), _T("20081216"));

	//t2̓̓G[
	Assert(ParseTask, _T("ť`ԈĂ܂B"), _T("-1"));
	Assert(ParseTask, _T("ť`ԈĂ܂B"), _T("-123"));
	Assert(ParseTask, _T("ť`ԈĂ܂B"), _T("-12345"));
	Assert(ParseTask, _T("ť`ԈĂ܂B"), _T("-1234567"));
	Assert(ParseTask, _T("ť`ԈĂ܂B"), _T("-123456789"));
	Assert(ParseTask, _T("ť`ԈĂ܂B"), _T("-12345678901"));
	Assert(ParseTask, _T("ť`ԈĂ܂B"), _T("-1234567890123"));
	Assert(ParseTask, _T("ť`ԈĂ܂B"), _T("-12345678901234"));
	Assert(ParseTask, _T("dł͎̓͂͂ł܂B"), _T("-020510"));
	Assert(ParseTask, _T("dł͎̓͂͂ł܂B"), _T("-02051030"));
	Assert(ParseTask, _T("dł͎̓͂͂ł܂B"), _T("-2008020510"));
	Assert(ParseTask, _T("dł͎̓͂͂ł܂B"), _T("-200802051030"));

	//t2̊̂()
	Assert(ParseTask, _T("0000/00/00 00:00,2010/01/14 00:00,,,true"), _T("-14"));
	Assert(ParseTask, _T("0000/00/00 00:00,2009/12/15 00:00,,,true"), _T("-15"));
	Assert(ParseTask, _T("0000/00/00 00:00,2009/12/16 00:00,,,true"), _T("-16"));

	//t2̊̂()
	Assert(ParseTask, _T("0000/00/00 00:00,2010/02/05 00:00,,,true"), _T("-0205"));
	Assert(ParseTask, _T("0000/00/00 00:00,2010/12/14 00:00,,,true"), _T("-1214"));
	Assert(ParseTask, _T("0000/00/00 00:00,2009/12/15 00:00,,,true"), _T("-1215"));
	Assert(ParseTask, _T("0000/00/00 00:00,2009/12/16 00:00,,,true"), _T("-1216"));

	//t2̊̂(N)
	Assert(ParseTask, _T("0000/00/00 00:00,2008/01/05 00:00,,,true"), _T("-20080105"));
	Assert(ParseTask, _T("0000/00/00 00:00,2008/12/14 00:00,,,true"), _T("-20081214"));
	Assert(ParseTask, _T("0000/00/00 00:00,2008/12/15 00:00,,,true"), _T("-20081215"));
	Assert(ParseTask, _T("0000/00/00 00:00,2008/12/16 00:00,,,true"), _T("-20081216"));

	//Jn̓̓G[
	Assert(ParseTask, _T("ť`ԈĂ܂B"), _T("1205-1"));
	Assert(ParseTask, _T("ť`ԈĂ܂B"), _T("1205-123"));
	Assert(ParseTask, _T("ť`ԈĂ܂B"), _T("1205-12345"));
	Assert(ParseTask, _T("ť`ԈĂ܂B"), _T("1205-1234567"));
	Assert(ParseTask, _T("ť`ԈĂ܂B"), _T("1205-123456789"));
	Assert(ParseTask, _T("ť`ԈĂ܂B"), _T("1205-12345678901"));
	Assert(ParseTask, _T("ť`ԈĂ܂B"), _T("1205-1234567890123"));
	Assert(ParseTask, _T("ť`ԈĂ܂B"), _T("1205-12345678901234"));
	Assert(ParseTask, _T("dł͎̓͂͂ł܂B"), _T("1205-020510"));
	Assert(ParseTask, _T("dł͎̓͂͂ł܂B"), _T("1205-02051030"));
	Assert(ParseTask, _T("dł͎̓͂͂ł܂B"), _T("1205-2008020510"));
	Assert(ParseTask, _T("dł͎̓͂͂ł܂B"), _T("1205-200802051030"));
	Assert(ParseTask, _T("ť`ԈĂ܂B"), _T("1-1205"));
	Assert(ParseTask, _T("ť`ԈĂ܂B"), _T("123-1205"));
	Assert(ParseTask, _T("ť`ԈĂ܂B"), _T("12345-1205"));
	Assert(ParseTask, _T("ť`ԈĂ܂B"), _T("1234567-1205"));
	Assert(ParseTask, _T("ť`ԈĂ܂B"), _T("123456789-1205"));
	Assert(ParseTask, _T("ť`ԈĂ܂B"), _T("12345678901-1205"));
	Assert(ParseTask, _T("ť`ԈĂ܂B"), _T("1234567890123-1205"));
	Assert(ParseTask, _T("ť`ԈĂ܂B"), _T("12345678901234-1205"));
	Assert(ParseTask, _T("dł͎̓͂͂ł܂B"), _T("020510-1205"));
	Assert(ParseTask, _T("dł͎̓͂͂ł܂B"), _T("02051030-1205"));
	Assert(ParseTask, _T("dł͎̓͂͂ł܂B"), _T("2008020510-1205"));
	Assert(ParseTask, _T("dł͎̓͂͂ł܂B"), _T("200802051030-1205"));

	//Jn(-)
	Assert(ParseTask, _T("2010/01/05 00:00,2010/02/03 00:00,,,true"), _T("05-03"));
	Assert(ParseTask, _T("2009/12/20 00:00,2010/01/19 00:00,,,true"), _T("20-19"));
	Assert(ParseTask, _T("2009/12/20 00:00,2009/12/20 00:00,,,true"), _T("20-20"));
	Assert(ParseTask, _T("2009/12/20 00:00,2009/12/21 00:00,,,true"), _T("20-21"));

	//JnI(-)
	Assert(ParseTask, _T("2010/01/05 00:00,2010/12/08 00:00,,,true"), _T("05-1208"));
	Assert(ParseTask, _T("2010/01/05 00:00,2011/01/04 00:00,,,true"), _T("05-0104"));
	Assert(ParseTask, _T("2009/12/20 00:00,2010/01/04 00:00,,,true"), _T("20-0104"));

	//JnI(-N)
	Assert(ParseTask, _T("2009/12/16 00:00,2010/12/20 00:00,,,true"), _T("16-20101220"));
	Assert(ParseTask, _T("JnłB"), _T("16-20090801"));

	//JnI(-)
	Assert(ParseTask, _T("2010/01/05 00:00,2010/01/08 00:00,,,true"), _T("0105-08"));
	Assert(ParseTask, _T("2010/01/20 00:00,2010/02/19 00:00,,,true"), _T("0120-19"));
	Assert(ParseTask, _T("2010/01/20 00:00,2010/01/20 00:00,,,true"), _T("0120-20"));
	Assert(ParseTask, _T("2010/01/20 00:00,2010/01/21 00:00,,,true"), _T("0120-21"));

	//JnI(-)
	Assert(ParseTask, _T("2010/01/05 00:00,2010/12/08 00:00,,,true"), _T("0105-1208"));
	Assert(ParseTask, _T("2010/01/05 00:00,2011/01/04 00:00,,,true"), _T("0105-0104"));

	//JnI(-N)
	Assert(ParseTask, _T("2009/12/15 00:00,2010/12/20 00:00,,,true"), _T("1215-20101220"));
	Assert(ParseTask, _T("JnłB"), _T("1216-20090801"));

	//JnI(N-)
	Assert(ParseTask, _T("2009/01/05 00:00,2009/01/08 00:00,,,true"), _T("20090105-08"));
	Assert(ParseTask, _T("2009/01/20 00:00,2009/02/19 00:00,,,true"), _T("20090120-19"));
	Assert(ParseTask, _T("2009/01/20 00:00,2009/01/20 00:00,,,true"), _T("20090120-20"));
	Assert(ParseTask, _T("2009/01/20 00:00,2009/01/21 00:00,,,true"), _T("20090120-21"));

	//JnI(N-)
	Assert(ParseTask, _T("2009/01/05 00:00,2009/12/08 00:00,,,true"), _T("20090105-1208"));
	Assert(ParseTask, _T("2009/01/05 00:00,2010/01/04 00:00,,,true"), _T("20090105-0104"));

	//JnI(N-N)
	Assert(ParseTask, _T("2008/12/15 00:00,2010/12/20 00:00,,,true"), _T("20081215-20101220"));
	Assert(ParseTask, _T("JnłB"), _T("20091216-20090801"));
}

//C
int _tmain(int argc, _TCHAR* argv[]) {
	//\͂̃eXg
	AssertAppointments();

	//d͂̃eXg
	AssertTasks();

	return 0;
}

